<?

ob_start("ob_gzhandler");

require_once("include/bittorrent.php");

hit_start();

dbconn();  // includes setting $CURUSER["foo"] if cookie present

hit_count();

// this will hold various GET parameters that need to be preserved between 
// functions and in generated URLs
$urlparams = array();


// this allows us to fool around with a test database
if (isset($_GET["testing"])) {
    $urlparams["testing"] = "1";
}


// handle the sort column specification
$sortcol = 4; # default sort column is 4 (date)
if (isset($_GET["sc"])) {
    $sortcol = 0 + $_GET["sc"];
    if($sortcol < 0 || $sortcol >= count($col_sortfields)) {
        $sortcol = 4;
    } else {
        $urlparams["sc"] = "$sortcol";
    }   
}       

// handle the sort order specification
$sortord = $col_sortorder[$sortcol];    // will contain either ASC or DESC
if (isset($_GET["so"])) {
    $tmp = strtolower($_GET["so"]);
    if ($tmp == "a") {
        $sortord = "ASC";
        $urlparams["so"] = "a";
    } elseif ($tmp == "d") {
        $sortord = "DESC";
        $urlparams["so"] = "d";
    }
}

// this will be used in the final query later
$orderby = "ORDER BY $col_sortfields[$sortcol] $sortord";

// this will be built up to enable filtering
$wherea = array();


// handle the owner filtering/searching
if( isset($_GET["owner"]) ) {
    
    $torrent_owner = preg_replace( "/[^\w.-]+/", "", unesc($_GET["owner"]) );
    if( strlen($torrent_owner) > 40 )
        $torrent_owner = substr($torrent_owner, 0, 40);
    
    $urlparams["owner"] = urlencode($torrent_owner);
    $wherea[] = "users.username LIKE '%" . sqlwildcardesc($torrent_owner) . "%'";
}


// handle "include dead torrents" as well as hiding banned and non-visible torrents
if ( isset($_GET["incldead"]) && $_GET["incldead"]) {
    $urlparams["incldead"] = "1";
    if (!isset($CURUSER) || $CURUSER["admin"] != "yes")
        $wherea[] = "banned != 'yes'";
} else
    $wherea[] = "visible = 'yes'";


$cats = genrelist();  # SELECT id, name, short_name FROM categories ORDER BY sort_index, id

// process the category filter
if (isset($_GET["cat"])) {
    $thiscat = 0 + $_GET["cat"];
    # N.B.: cat=0 means all, so don't bother applying or propagating it if it's 0
    if($thiscat > 0 && $thiscat <= highest_catid()) {
        $wherea[] = "category = " . sqlesc($thiscat);
        $urlparams["cat"] = "$thiscat";
    } else {
        $thiscat = 0;   // means no filter, show all cats
    }
}


// handle the keyword search filter
if ( isset($_GET["search"]) ) {

    // preserve this for later
    $wherebase = $wherea;

    $searchstr = unesc($_GET["search"]);
    $cleansearchstr = searchfield($searchstr);

    if (empty($cleansearchstr)) {
        unset($cleansearchstr);
    } else {
        $wherea[] = "MATCH (search_text, ori_descr) AGAINST (" . sqlesc($searchstr) . ")";
        $urlparams["search"] = urlencode($searchstr);
    }
}

#$debug = "";

// combine the filters and see how many hits we're looking at
$where = implode(" AND ", $wherea);
if ($where != "")
    $where = "WHERE $where";


$count_query = "SELECT COUNT(*) FROM torrents " . 
               (isset($urlparams["owner"]) ? "LEFT JOIN users ON torrents.owner = users.id " : "") .
               "$where";
$res = mysql_query($count_query) or die(mysql_error());
$row = mysql_fetch_array($res);
$count = $row[0];
#$debug .= "First query: " . htmlspecialchars($count_query) . "<br />First count: $count<br />";

// if this was a keyword search and no matches, try the more expensive wildcard search
if (!$count && isset($cleansearchstr)) {
    $wherea = $wherebase;       // reverts back to its original form
    $searcha = explode(" ", $cleansearchstr);
    $sc = 0;
    foreach ($searcha as $searchss) {
        if (strlen($searchss) <= 1)
            continue;
        $sc++;
        if ($sc > 5)
            break;
        $ssa = array();
        foreach (array("search_text", "ori_descr") as $sss)
            $ssa[] = "$sss LIKE '%" . sqlwildcardesc($searchss) . "%'";     // sqlwildcardesc: puts backslashes before % and _
        $wherea[] = "(" . implode(" OR ", $ssa) . ")";
    }
    if ($sc) {
        $where = implode(" AND ", $wherea);
        if ($where != "")
            $where = "WHERE $where";

        $count_query = "SELECT COUNT(*) FROM torrents " . 
                       (isset($urlparams["owner"]) ? "LEFT JOIN users ON torrents.owner = users.id " : "") .
                       "$where";
        $res = mysql_query($count_query) or die(mysql_error());
        $row = mysql_fetch_array($res);
        $count = $row[0];
        #$debug .= "Second query: " . htmlspecialchars($count_query) . "<br />Second count: $count<br />";
    }
}


# ---------------
# by this point, the number of torrents to display has been determined as $count
# the $where, $orderby, and $limit clauses have all been determined
# ---------------

#print "<p>$debug</p>\n\n";


if ($count) {
    if (isset($CURUSER) && isset($CURUSER["rpp"])) {
        $rpp = 0 + $CURUSER["rpp"];
        if ($rpp < 10)
            $rpp = 10;
        if ($rpp > 500)
            $rpp = 500;
    } else {
        $rpp = 20;
    }    

    if (isset($_GET["page"])) {

        $tmp = 0 + $_GET["page"];
        if( $tmp >= 1 && $tmp <= ceil($count / $rpp) ) {
            $urlparams["page"] = "$tmp";        # this is how current page is communicated to pagernew() 
        }
    }
    
    list($pagertop, $pagerbottom, $limit) = pagernew($rpp, $count, $urlparams);

    $query = "SELECT *, torrents.name AS name, torrents.id AS id, UNIX_TIMESTAMP() - UNIX_TIMESTAMP(torrents.added) AS added_relative, categories.short_name AS cat_name, users.username FROM torrents LEFT JOIN categories ON category = categories.id LEFT JOIN users ON torrents.owner = users.id $where $orderby $limit";
    $res = mysql_query($query)
        or die(mysql_error());
} else
    unset($res);

if ($count == 1) {
    $row = mysql_fetch_array($res);
    header("Refresh: 0; url=details.php?id=" . $row["id"] . "&searched=" . urlencode($searchstr));
    hit_end();
    exit();
}

$additionals = 0;

if (isset($cleansearchstr)) {
    stdhead("Search results for \"$searchstr\"");
} elseif ($thiscat != 0) {
    $curcat = "(unknown)";
    foreach($cats as $c)
        if( $c["id"] == $thiscat )
            $curcat = $c["name"];
    stdhead("Category listing: $curcat");
} else {
    stdhead();

    if ($_SERVER["QUERY_STRING"] == "") {
        // $additionals = 1;

?>
<script language="javascript">
<!--
if (parent.frames.length > 0) {
    parent.location.href = self.document.location;
}
// -->
</script>
<div class=title><img width="467" height="161" src="http://static.voracity.net/pic/voracity.gif" alt="vo-rac'i-ty: n. an insatiable appetite for an activity or pursuit" /></div>
<?
    }
}



$catdropdown = "";
foreach ($cats as $cat) {
    $catdropdown .= "<option class=\"cat" . $cat["id"] . "\" value=\"" . $cat["id"] . "\"";
    if ($cat["id"] == $thiscat)
        $catdropdown .= " selected=\"selected\"";
    $catdropdown .= ">" . htmlspecialchars($cat["name"]) . "</option>\n";
}

?>

<div id="navcontainer"><table><tr>
<? 
$tmp_urlparams = $urlparams;
unset($tmp_urlparams["search"]);    # when clicking on a category filter button, don't carry over a search (reset the search param)
unset($tmp_urlparams["page"]);      # ... and start at page 1 of the new cat

foreach ($cats as $cat)
    print "<td" . ($cat["id"] == $thiscat ? " id=\"navselected\"" : "") . "><a class=\"cat" . $cat["id"] . "\" href=\"" . 
        mkurl( array_merge($tmp_urlparams, array("cat" => $cat["id"]))) . "\">" . htmlspecialchars($cat["short_name"]) . "</a></td>";
?>
</tr></table></div>


<div id="searchcontainer">
<ul><form method="get" action="<?= $_SERVER["SCRIPT_NAME"] ?>">
<li><input type="submit" value="Search" /></li>
<li><input type="text" name="search" size="20" maxlength="40" class="searchbox" value="<?= htmlspecialchars($searchstr) ?>" /></li>
<li>in <select name="cat"><option value="0">(all types)</option><?= $catdropdown ?></select></li>
<li><input type="checkbox" name="incldead" value="1"<?= ($_GET["incldead"] ? "checked=\"checked\"" : "") ?> /> include unseeded?</li>
<? 
foreach ($urlparams as $p => $val) { 
    if( strtolower($p) != "search" && strtolower($p) != "page" && strtolower($p) != "incldead" && strtolower($p) != "cat") 
        print "<input type=\"hidden\" name=\"$p\" value=\"$val\" />"; 
} 
?>
</form></ul>
</div>


<?


if (isset($cleansearchstr)) {
    $tmp_urlparams = $urlparams;
    unset($tmp_urlparams["search"]);
    $link = mkurl($tmp_urlparams);   
    print "<p class=\"filtering\">Filtering on search keywords \"" . htmlspecialchars($searchstr) . 
          "\" <a href=\"$link\">(remove filter)</a></p>\n";
}          
    
if (isset($torrent_owner)) {
    $tmp_urlparams = $urlparams;
    unset($tmp_urlparams["owner"]);
    $link = mkurl($tmp_urlparams);
    print "<p class=\"filtering\">Displaying torrents submitted by " . htmlspecialchars($torrent_owner) . 
          " <a href=\"$link\">(remove filter)</a></p>\n";
}          
 

if ($count) {
    print($pagertop);

    if(isset($_GET["my"]))
        $mytorrents = true;
    else
        $mytorrents = false;
        
    $up_arrow = "&nbsp;&#9650;";
    $down_arrow = "&nbsp;&#9660;";
    
    if($CURUSER)
        $prefs = $CURUSER;
    else
        $prefs = $default_prefs;

    print "<div id=\"ttcontainer\"><table id=\"torrents\">\n";
    
    $colgroup = "";
    $colheaders = "";
    
    # print out a list of column groups
    for ($i = 0; $i < count($col_ids); $i++) {
    
        if ($colprefs[$i] && $prefs[$colprefs[$i]] != "yes")
            continue;   # skip columns the user has ignored
    
        if ($col_ids[$i] == "catcol" && $thiscat > 0)
            continue;   # skip printing the type column when filtering on a specific type
    
        if ($col_ids[$i] == "viscol" && !$mytorrents)
            continue;   # skip visible col. unless we're showing "my torrents"
            
        if ($col_ids[$i] == "ownercol" && isset($urlparams["owner"]))
            continue;   # don't show owner col. if filtering
        
        $colgroup .= "<col class=\"" . $col_ids[$i] . "\" width=\"" . ($col_ids[$i] == "namecol" ? "*" : "0*") . "\" />";
        if( $i == $sortcol ) {      # click on the link for the current sorted column results in reversing the sort order 
            if( strtoupper($sortord) == "ASC" ) {
                $href = mkurl( array_merge( $urlparams, array( "so" => "d" )));
                $arrow = $col_sortorder[$i] == 'DESC' ? $up_arrow : $down_arrow;        # this is a silly hack, it's using col_sortorder to differentiate between numeric and alpha column types
            } else {
                $href = mkurl( array_merge( $urlparams, array( "so" => "a" )));
                $arrow = $col_sortorder[$i] == 'DESC' ? $down_arrow : $up_arrow;        # ditto
            }
            $class = "class=\"sortcol\"";
        } else {                    # click on a new column and use its default sort order
            $tmp_urlparams = $urlparams;
            unset($tmp_urlparams["so"]);        # make a copy and remove the sort order -- use default of the new column
            $tmp_urlparams["sc"] = "$i";
            $href = mkurl( $tmp_urlparams );
            $arrow = "";
            $class = "";
        }
                
        $colheaders .= "<th $class><a href=\"$href\">$table_hdrs[$i]$arrow</a></th>";
    }
    
    print "<colgroup>$colgroup</colgroup>\n<tr class=\"headtop\">$colheaders</tr><tr class=\"spacertop\"><td colspan=\"0\" /></tr>\n";
    
    while ($row = mysql_fetch_assoc($res)) {
        $id = $row["id"];

        /* start a row for the torrent and assign it a class so it can be colored */
        print "<tr class=\"" . (isset($row["cat_name"]) ? "cat" . $row["category"] : "catnone") . "\">";

        if ($prefs["colpref_cat"] == "yes" && $thiscat == 0) // only print if we're showing all cats
            print "<td class=\"$col_ids[0]\"><a href=\"index.php?cat=" . $row["category"] . "\">" . $row["cat_name"] . "</a></td>\n";

        if ($prefs["colpref_name"] == "yes") {
            $dispname = preg_replace( "/([\.\,\_\-\[\]\{\}\(\)]+)/", "$1&shy;", htmlspecialchars($row["name"]));
            
            $torrentlink = "download.php/$id/" . rawurlencode($row["filename"]);
            if ($mytorrents)
                $detailslink = "details.php?id=$id&amp;returnto=" . urlencode($_SERVER["REQUEST_URI"]);
            else
                $detailslink = "details.php?id=$id&amp;hit=1";

            if (isset($_GET["testing"]))
                $detailslink .= "&amp;testing=1";                

            if(isset($CURUSER) && $CURUSER["username"] == $row["username"])
                $editlink = " <a class=\"editlink\" href=\"edit.php?id=$id&amp;returnto=" . urlencode($_SERVER["REQUEST_URI"]) . 
                            (isset($_GET["testing"]) ? "&amp;testing=1" : "") . "\">(edit)</a>";
            else
                $editlink = "";
       
            print "<td class=\"$col_ids[1]\"><a href=\"$torrentlink\">$dispname</a> <a class=\"detailslink\" href=\"$detailslink\">(details)</a>$editlink</td>\n";
        
        }

        if ($mytorrents)
            print "<td class=\"$col_ids[2]\">" . $row["visible"] . "</td>\n";

        if ($prefs["colpref_comm"] == "yes") {
            if ($row["comments"]) {
                if (!$mytorrents)
                    $commentslink = "details.php?id=$id&amp;hit=1&amp;tocomm=1";
                else
                    $commentslink = "details.php?id=$id&amp;page=0#startcomments";
                
                if (isset($_GET["testing"]))
                    $commentslink .= "&amp;testing=1";                
                    
                print "<td class=\"$col_ids[3]\"><a href=\"$commentslink\">" . $row["comments"] . "</a></td>\n";
            } else
                print "<td class=\"$col_ids[3]\">0</td>\n";
        }

        if ($prefs["colpref_added"] == "yes")
            print "<td class=\"$col_ids[4]\">" . mkprettytime2($row["added_relative"]) . "</td>\n";
        
        if ($prefs["colpref_nfiles"] == "yes")
            print "<td class=\"$col_ids[5]\">" . $row["numfiles"] . "</td>\n";
        
        if ($prefs["colpref_size"] == "yes")
            print "<td class=\"$col_ids[6]\">" . mksize($row["size"], "1") . "</td>\n";
            
        if ($prefs["colpref_views"] == "yes")
            print "<td class=\"$col_ids[7]\">" . $row["views"] . "</td>\n";

        if ($prefs["colpref_hits"] == "yes")
            print "<td class=\"$col_ids[8]\">" . $row["hits"] . "</td>\n";

        if ($prefs["colpref_completes"] == "yes")
            print "<td class=\"$col_ids[9]\">" . $row["times_completed"] . "</td>\n";

        if ($prefs["colpref_seeders"] == "yes") {
            if ($row["seeders"]) {
                if (!$mytorrents)
                    $statslink = "details.php?id=$id&amp;hit=1&amp;toseeders=1";
                else
                    $statslink = "details.php?id=$id&amp;dllist=1#seeders";

                if (isset($_GET["testing"]))
                    $statslink .= "&amp;testing=1";                
    
                print "<td class=\"$col_ids[10]\"><a class=\"" . linkcolor($row["seeders"]) . "\" href=\"$statslink\">" . $row["seeders"] . "</a></td>\n";
            } else
                print "<td class=\"$col_ids[10]\"><span class=\"" . linkcolor($row["seeders"]) . "\">" . $row["seeders"] . "</span></td>\n";
        }
           
        if ($prefs["colpref_leechers"] == "yes") {
            if ($row["leechers"]) {
                if (!$mytorrents)
                    $statslink = "details.php?id=$id&amp;hit=1&amp;todlers=1";
                else
                    $statslink = "details.php?id=$id&amp;dllist=1#leechers";

                if (isset($_GET["testing"]))
                    $statslink .= "&amp;testing=1";
                    
                print "<td class=\"$col_ids[11]\"><a class=\"" . linkcolor($row["leechers"]) . "\" href=\"$statslink\">" . $row["leechers"] . "</a></td>\n";
            } else
                print "<td class=\"$col_ids[11]\"><span class=\"" . linkcolor($row["leechers"]) . "\">" . $row["leechers"] . "</span></td>\n";
        }

        if ($prefs["colpref_owner"] == "yes" && !$mytorrents && !isset($urlparams["owner"])) {
            if( isset($row["username"]) ) {
                $tmp_urlparams = $urlparams;
                unset($tmp_urlparams["cat"]);   # when clicking on the name, reset any category filter in effect
                unset($tmp_urlparams["page"]);  # also goto page 1
                $tmp_urlparams["owner"] = $row["username"];
                $tmp_urlparams["incldead"] = 1; # show all of user's torrents

                # 'htmlspecialchars' shouldn't be necessary, username is /^[a-z][\w.-]*$/ 
                print "<td class=\"$col_ids[12]\">" .
                      "<a href=\"" . mkurl( $tmp_urlparams ) . "\">" .
                      htmlspecialchars($row["username"]) .   
                      "</a></td>\n";
            } else {
                print "<td class=\"$col_ids[12]\"><i>(unknown)</i></td>\n";
            }            
        }

        print "</tr>\n";
    }

    print "<tr class=\"spacerbot\"><td colspan=\"0\" /></tr><tr class=\"headbot\">$colheaders</tr>\n</table></div>\n";

    print $pagerbottom;

} else {
    if (isset($cleansearchstr)) {
        print("<h2>Nothing found!</h2>\n");
        print("<p>Try again with a refined search string.</p>\n");
    } else {
        print("<h2>Nothing here!</h2>\n");
        print("<p>Sorry pal :(</p>\n");
    }
}

stdfoot();

hit_end();

?>
